#include "BmnTrcCountersDialog.h"
#include "ui_BmnTrcCountersDialog.h"

#include <QTableView>

#include "RcCountersModel.h"
#include "BmnTrcSignalRouter.h"

BmnTrcCountersDialog::BmnTrcCountersDialog(QWidget *parent)
    : QDialog(parent)
    , ui(new Ui::BmnTrcCountersDialog)
{
    ui->setupUi(this);

    auto pairs = {std::pair{DevCountersTrcIn, "Input counters"},
                  std::pair{DevCountersTrcBa, "Before/After errors"},
                  std::pair{DevCountersTrcReduc, "Input counters (after reduction)"}};

    for(auto p : pairs) {
        auto tab = new QWidget(this);
        auto layout = new QVBoxLayout(tab);
        auto tableView = new QTableView(tab);
        layout->addWidget(tableView);
        ui->tabWidget->addTab(tab, p.second);

        auto model = new RcCountersModel(p.first, this);

        BmnTrcSignalRouter::instance().setRcCountersModel(p.first, model);
        tableView->setModel(model);
        connect(model, &QAbstractItemModel::modelReset,
                tableView, &QTableView::resizeColumnsToContents);
        tableView->resizeColumnsToContents();
    }
}

BmnTrcCountersDialog::~BmnTrcCountersDialog()
{
    delete ui;
}

void BmnTrcCountersDialog::on_buttonBox_clicked(QAbstractButton *button)
{
    switch (ui->buttonBox->standardButton(button)) {
    case QDialogButtonBox::Ok:
        accept();
        return;
    case QDialogButtonBox::Reset:
        emit clearStat();
        return;
    default:
        Q_UNREACHABLE();
    }
}

