#include "RegTypeComboBoxDelegate.h"

#include <QComboBox>
#include <QDebug>

RegTypeComboBoxDelegate::RegTypeComboBoxDelegate(QObject *parent)
    : QItemDelegate(parent)
{
}

QWidget *RegTypeComboBoxDelegate::createEditor(QWidget *parent, const QStyleOptionViewItem &option, const QModelIndex &index) const
{
    auto cb = new QComboBox(parent);
    cb->setSizeAdjustPolicy(QComboBox::AdjustToContents);
    cb->addItems({"16-bit", "32-bit", "64-bit"});

    auto val = index.model()->data(index, Qt::EditRole).toInt();
    cb->setCurrentIndex(val);
    connect(cb, &QComboBox::currentTextChanged,
            this, &RegTypeComboBoxDelegate::dataChanged);

    return cb;
}

void RegTypeComboBoxDelegate::setEditorData(QWidget *editor, const QModelIndex &index) const
{
    auto value = index.model()->data(index, Qt::EditRole).toULongLong();
    auto cb = static_cast<QComboBox*>(editor);
    if(cb->currentIndex() == value)
        return;
    QSignalBlocker block(cb);
    cb->setCurrentIndex(value);
}

void RegTypeComboBoxDelegate::setModelData(QWidget *editor, QAbstractItemModel *model, const QModelIndex &index) const
{
    auto cb = static_cast<QComboBox*>(editor);
    auto val = cb->currentIndex();
    if(model->data(index, Qt::EditRole).toUInt() != val)
        model->setData(index, val, Qt::EditRole);
}

void RegTypeComboBoxDelegate::dataChanged()
{
    commitData(qobject_cast<QWidget*>(sender()));

//    if(commitDataWidget) {
//        if(commitDataWidget == sender())
//            return;
//        flushCommitData();
//    }
//    commitDataWidget = sender();
//    commitDataTimer->start();
}
