
#include <iostream>

#include <QApplication>
#include <QDebug>
#include <QString>

#include "DeviceDiscoverMainWindow.h"
#include "base/Globals.h"
#include "base/SyslogMessageSender.h"
#include "device-discover/DiscoverDialog.h"

int main(int argc, char *argv[])
{
    QCoreApplication::setOrganizationName(Globals::organizationName);
    QCoreApplication::setOrganizationDomain(Globals::organizationDomain);
    QCoreApplication::setApplicationName("MLDiscover");
    SyslogMessageSender::instance().install();

    int ret = 1;
    try {
        QApplication a(argc, argv);
        DeviceDiscoverMainWindow w;
        w.show();
        ret = a.exec();
    } catch (std::exception &e) {
        std::cerr << "Exception: " << e.what () << std::endl;
    }

    return ret;
}
