#ifndef EVBGENAPP_H
#define EVBGENAPP_H

#include "app/DaqGuiApp.h"
#include "GenStartupOptions.h"

class EvbGenApp : public DaqGuiApp
{
public:
    EvbGenApp(int &_argc, char *_argv[]);
    GenStartupOptions getStartupOptions() const { return so; }
    int exec() override;

protected:
    virtual void setupOptions() override;
    virtual void processParseResults(QCommandLineParser &parser) override;
    virtual bool hasConfigSelectorOption() const override { return true; }

private:
    QCommandLineOption spillCnt_option;
    QCommandLineOption spillDuration_option;
    QCommandLineOption interSpillDuration_option;
    QCommandLineOption evRate_option;
    QCommandLineOption evLen_option;

    QCommandLineOption numberOfClients_option;

    GenStartupOptions so;
};

#endif // EVBGENAPP_H
