#include "EvbGenSignalRouter.h"

#include "EvbGenCore.h"
#include "EvbGenMainWindow.h"

void EvbGenSignalRouter::setCore(EvbGenCore *p)
{
    core = p;
    BaseSignalRouter::setBaseAppCore(core);
}

void EvbGenSignalRouter::connect_MainWindow() const
{
    BaseSignalRouter::connect_MainWindow();
    if(!mainWindow)
        return;

    if(mainFsm)
        connect(mainFsm, &BaseFsm::stateChanged,
                mainWindow, &EvbGenMainWindow::onFsmStateChange);

    if(core) {
        connect(core, &EvbGenCore::runProgressChanged,
                mainWindow, &EvbGenMainWindow::onRunProgressChange);
    connect(mainWindow, &EvbGenMainWindow::performLocalStart,
            core, &EvbGenCore::performLocalStart);

    connect(mainWindow, &EvbGenMainWindow::performLocalStop,
            core, &EvbGenCore::performLocalStop);
    }

    if(remoteControlServer)
        connect(remoteControlServer, &RemoteControlServer::connectionStatusUpdated,
                mainWindow, &EvbGenMainWindow::onRemoteStatusUpdated);

}

void EvbGenSignalRouter::connect_RemoteControlServer() const
{
    BaseSignalRouter::connect_RemoteControlServer();
    if(core) {
        connect(remoteControlServer, &RemoteControlServer::startRequest,
                core, &EvbGenCore::onRemoteStartRequest);
        connect(remoteControlServer, &RemoteControlServer::stopRequest,
                core, &EvbGenCore::onRemoteStopRequest);
        connect(core, &EvbGenCore::sendRunError,
                remoteControlServer, &RemoteControlServer::onRunError);
        connect(core, &EvbGenCore::sendRunWarning,
                remoteControlServer, &RemoteControlServer::onRunWarning);
    }
}
