#ifndef EVBCLIENTMANAGERFSM_H
#define EVBCLIENTMANAGERFSM_H

#include "BaseEvbClientFsm.h"
#include "base/ClientIndex.h"

class ClientIndexEnabledMap;

struct EvbClientManagerFsmInput : public BaseFsmInput
{
    ClientIndexSet clientsSet;
    QMap<ClientIndex, FsmState> clientsStates;
};

class EvbClientManagerFsm : public BaseEvbClientFsm
{
    Q_OBJECT
public:
    EvbClientManagerFsm(QObject *parent = nullptr);
    bool canSwitchTo(FsmState state) const;

signals:
    void clientListChanged(const ClientIndexEnabledMap &);

public slots:
    void setClientList(const ClientIndexEnabledMap &newList);
    void setClientState(ClientIndex index, FsmState state);

protected:
    inline EvbClientManagerFsmInput *getInput() {
        return static_cast<EvbClientManagerFsmInput*>(BaseFsm::getInput());
    }
    inline const EvbClientManagerFsmInput *getInput() const {
        return static_cast<const EvbClientManagerFsmInput*>(BaseFsm::getInput());
    }
    virtual void printInputString(QDebug dbg) const override;

    virtual void doReqStateActions(const FsmState &) override {}
    bool checkSubStates(const FsmState &state) const final;
    bool hasAnyError() const final;
};

QDebug operator<<(QDebug dbg, const EvbClientManagerFsmInput &in);

#endif // EVBCLIENTMANAGERFSM_H
