#ifndef FILESPLITDIALOG_H
#define FILESPLITDIALOG_H

#include <QDialog>

namespace Ui {
class FileSplitDialog;
}

struct EvbFileSplitterConfig;

class FileSplitDialog : public QDialog
{
    Q_OBJECT

public:
    explicit FileSplitDialog(QWidget *parent = nullptr);
    virtual ~FileSplitDialog() override;

signals: void fileSplitterConfigChanged(const EvbFileSplitterConfig &) const;
public slots: void setFileSplitterConfig(const EvbFileSplitterConfig &newConfig);

private slots:
    void on_groupBoxEvNum_toggled(bool en);
    void on_spinBoxEventNum_valueChanged(int val);
    void on_groupBoxFileSize_toggled(bool en);
    void on_spinBoxFileSize_valueChanged(int val);
    void on_groupBoxTime_toggled(bool en);
    void on_spinBoxTime_valueChanged(int val);

private:
    void updateGui() const;

    Ui::FileSplitDialog *ui;
    EvbFileSplitterConfig * const cfg;
};

#endif // FILESPLITDIALOG_H
