#ifndef EVBCLIENTSTATUSTABLEVIEW_H
#define EVBCLIENTSTATUSTABLEVIEW_H

#include <QTableView>

#include "base/ClientIndex.h"

class ClientEnableTableModel;
class EvbClientStatusModel;
class MergeColumnsTableModel;

struct ClientIndexEnabledMap;
struct CombinerStats;
struct TcpClientStatus;

class EvbClientStatusTableView : public QTableView
{
    Q_OBJECT
public:
    EvbClientStatusTableView(QWidget *p);
    void setShowAdvancedCounters(bool showColumns);
    void setShowTimeDistrCol(bool showColumns);
    ClientIndexSet getSelectedClients() const;
    void setControlEnabled(bool en);

signals:
    void clientListChanged(const ClientIndexEnabledMap &) const;
    void combinerStatsUpdated(const CombinerStats &cs) const;
    void clientStatusUpdated(const TcpClientStatus &status);
    void clientSelectionChanged(bool hasSelected) const;

public slots:
    void setClientList(const ClientIndexEnabledMap &newList);
    void setSubModelColHidden(int col, bool hidden);

protected:
    void selectionChanged(const QItemSelection &selected, const QItemSelection &deselected) override;

private:
    // QList<DeviceIndexTableModel *> subModels;

    ClientEnableTableModel * const enabledModel;
    EvbClientStatusModel * const statusModel;
    MergeColumnsTableModel * const mergeModel;
};

#endif // EVBCLIENTSTATUSTABLEVIEW_H
