#ifndef MPDTRCDEVICE_H
#define MPDTRCDEVICE_H

#include "ModularMregDevice.h"
#include "ModularDeviceStatus.h"

struct MpdTrcBuildParams;
struct Ut24TtlIoBuildParams;
struct Ut24TtlIoConfig;

class MpdTrcDevice : public ModularMregDevice
{
    Q_OBJECT
public:
    explicit MpdTrcDevice(const DeviceIndex &index, QObject *parent = nullptr);

public slots:
    void preRunReset(const QVariant &startEvNum);

signals:
    void mpdTrcBpUpdated(const DeviceIndex &index, const MpdTrcBuildParams &bp) const;
    void ut24TtlIoBpUpdated(const DeviceIndex &index, const Ut24TtlIoBuildParams &bp) const;
    void ut24TtlIoStartupCfgUpdated(const DeviceIndex &index, const Ut24TtlIoConfig &bp) const;

protected:
    virtual void initModules() override;
    bool writeConfig() override;

private:
    ModularDeviceStatus statusCache;
};

#endif // MPDTRCDEVICE_H
