#ifndef MPDTRCSIGNALROUTER_H
#define MPDTRCSIGNALROUTER_H

#include "lib-common/ReadoutAppSignalRouter.h"

class ReadoutAppConfigDb;
class MpdTrcConfigDispatcher;
class MpdTrcCore;
class MpdTrcDeviceGlobal;
class MpdTrcMainWindow;
class MpdTrcChModel;
class Ut24TtlIoWidget;

class MpdTrcSignalRouter : public ReadoutAppSignalRouter
{
    MpdTrcSignalRouter();
    Q_DISABLE_COPY_MOVE(MpdTrcSignalRouter)
public:
    // Singleton
    static MpdTrcSignalRouter & instance()
    {
        // thread-safe since C++11
        static MpdTrcSignalRouter obj;
        return obj;
    }

    void setCore(MpdTrcCore *p);
    void setConfigDb(ReadoutAppConfigDb * p)
    { configDb = p; }
    void setMainWindow(MpdTrcMainWindow *p);
    void setMpdTrcConfigDispatcher(MpdTrcConfigDispatcher *p);

    // void connectAll() const override;
    void connect_TluDeviceGlobal(const MpdTrcDeviceGlobal *devGlob);

protected:
    virtual void connect_ConfigurationDispatcher() const override;
    virtual void connect_FSM() const override;
    virtual void connect_MainWindow() const override;
    void connect_deviceDispatcher() const override;

    ReadoutAppConfigDb * configDb = nullptr;
    MpdTrcConfigDispatcher *trcConfDisp = nullptr;
    MpdTrcCore *core = nullptr;
    MpdTrcMainWindow  *trcMw = nullptr;
    MpdTrcChModel *trcChModel = nullptr;
    Ut24TtlIoWidget *ttlIoWidget = nullptr;
};

#endif // MPDTRCSIGNALROUTER_H
