#ifndef MPDTRCCHMODELITEM_H
#define MPDTRCCHMODELITEM_H

#include "base/DeviceIndex.h"

struct MpdTrcChModelItem
{
    explicit MpdTrcChModelItem() = default;
    ~MpdTrcChModelItem() {
        qDeleteAll(children);
    }
    MpdTrcChModelItem *child(int row) const { return children.value(row, nullptr); }
    MpdTrcChModelItem *createChild() {
        auto child = new MpdTrcChModelItem();
        child->dev = dev;
        child->parent = this;
        children.push_back(child);
        return child;
    }
    int childCount() const { return children.size();}
    int row() const {
        if(parent)
            return parent->children.indexOf(const_cast<MpdTrcChModelItem*>(this));
        return 0;
    }

    DeviceIndex dev;
    int ch=-1;
    MpdTrcChModelItem *parent = nullptr;
    QVector<MpdTrcChModelItem *> children;
};
#endif // MPDTRCCHMODELITEM_H
