#ifndef MPDTRCCHWIDGET_H
#define MPDTRCCHWIDGET_H

#include <QWidget>

#include "device-modules/Tlu16SfpTrigger/Tlu16SfpTriggerBuildParams.h"
#include "device-modules/Tlu16SfpTrigger/Tlu16SfpTriggerConfig.h"
#include "fsm/FsmState.h"
#include "lib-common/BaseDeviceAppConfig.h"

struct Tlu16SfpTriggerBuildParams;
class MpdTrcChModel;
class ConfigKey;
class CommonSpinBoxDelegate;

namespace Ui {
class MpdTrcChWidget;
}

class MpdTrcChWidget : public QWidget
{
    Q_OBJECT

public:
    explicit MpdTrcChWidget(QWidget *parent = nullptr);
    ~MpdTrcChWidget();
    MpdTrcChModel *getModel() const { return model; }

public slots:
    void updateRemoteBlocking(bool remoteConnected) const;
    void onFsmStateChange(const FsmState &state);

private slots:
    void onModelReset();

private:
    void addDelegate(const QModelIndex &index);

    Ui::MpdTrcChWidget *ui;
    MpdTrcChModel * const model;
    CommonSpinBoxDelegate * const thrSbDelegate;
};

#endif // MPDTRCCHWIDGET_H
