#ifndef MPDTRCLOGICFORM_H
#define MPDTRCLOGICFORM_H

#include <QWidget>

#include "MpdTrc/MpdTrcConfig.h"
#include "MpdTrc/MpdTrcBuildParams.h"

#include "lib-common/BaseDeviceAppConfig.h"

class QComboBox;
class QSpinBox;
class ConfigKey;

namespace Ui {
class MpdTrcLogicForm;
}

class MpdTrcLogicForm : public QWidget
{
    Q_OBJECT

public:
    explicit MpdTrcLogicForm(QWidget *parent = nullptr);
    ~MpdTrcLogicForm();

signals:
    void mpdTrcConfigChanged(const MpdTrcConfig &config) const;

public slots:
    void setMpdTrcConfig(const MpdTrcConfig &newConfig);
    void setMpdTrcBp(const DeviceIndex &index, const MpdTrcBuildParams &bp);

private slots:
    void updateLutConfigByGui();

    void on_comboBoxEast_currentIndexChanged(int index);
    void on_spinBoxEastThr_valueChanged(int arg1);
    void on_comboBoxWest_currentIndexChanged(int index);
    void on_spinBoxWestThr_valueChanged(int arg1);
    void on_comboBoxOut_currentIndexChanged(int index);
    void on_radioButtonPhyOr_toggled(bool) { updateLutConfigByGui(); }
    void on_radioButtonPhyAnd_toggled(bool) { updateLutConfigByGui(); }

private:
    void updateGui();
    void initFhcalLogic(QComboBox *cb, QSpinBox *sb);
    void initFhcalOutLogic();
    void initPhyTrigs(quint16 chNum);

    Ui::MpdTrcLogicForm *ui;
    MpdTrcConfig config;
    QMap<DeviceIndex, MpdTrcBuildParams> buildParams;
    quint16 phyChNum = 0;
};

#endif // MPDTRCLOGICFORM_H
