#ifndef MSCSTATUSPUBLISHER_H
#define MSCSTATUSPUBLISHER_H

#include <QElapsedTimer>
#include <QObject>

#include "base/ConfigIndexName.h"
#include "base/DeviceIndex.h"
#include "data/MscHistData.h"
#include "fsm/FsmState.h"
#include "lib-common/BaseDeviceAppConfig.h"

class ConfigIndexName;
class ConfigKey;
class MscStatusPublisherPrivate;

class QTimer;

class MscStatusPublisher : public QObject
{
    Q_OBJECT

public:
    explicit MscStatusPublisher(QObject *parent = nullptr);

signals:
    void switch_to_config(const ConfigIndexName &conf) const;

public slots:
    void configSelectorChanged(const ConfigIndexName &conf);
    void onDeviceMgrFsmStateChanged(const FsmState &state);
    void histUpdated(const DeviceIndex &index, const MscDevHists &h);

private slots:
    void flushHists();

signals: void configChanged(const BaseDeviceAppConfig &config) const;
public slots: void setConfig(const ConfigKey &config_key, const BaseDeviceAppConfig &newConfig);

private:
    void flushHist(const DeviceIndex &index);
    void pub(const QString &key, const QJsonDocument &json);

    ConfigIndexName config_index;
    BaseDeviceAppConfig cfg;

    QTimer * const flushTimer;

    Q_DECLARE_PRIVATE(MscStatusPublisher)
    MscStatusPublisherPrivate * const d_ptr;
};

#endif // MSCSTATUSPUBLISHER_H
