#include "MscBaseDelegate.h"

#include <QTimer>

MscBaseDelegate::MscBaseDelegate(QObject *parent)
    : QItemDelegate(parent)
    , commitDataTimer(new QTimer(this))
{
    commitDataTimer->setInterval(0);
    commitDataTimer->setSingleShot(true);
    connect(commitDataTimer, &QTimer::timeout,
            this, &MscBaseDelegate::flushCommitData);
}


void MscBaseDelegate::updateEditorGeometry(QWidget *editor,
                                       const QStyleOptionViewItem &option,
                                       const QModelIndex &) const
{
    editor->setGeometry(option.rect);
}


void MscBaseDelegate::dataChanged()
{
    if(commitDataWidget) {
        if(commitDataWidget == sender()){
            return;
        }
        flushCommitData();
    }
    commitDataWidget = sender();
    commitDataTimer->start();
}

void MscBaseDelegate::flushCommitData()
{
    if(!commitDataWidget)
        return;
    commitData(qobject_cast<QWidget*>(commitDataWidget));
    commitDataWidget = nullptr;
}
