/*
**    Copyright 2014-2020 Ivan Filippov
**    Copyright 2014-2020 Ilja Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "RcConfigDb.h"
#include "RcConfigConverter.h"

RcConfigDb::RcConfigDb(QObject *parent)
    : AbstractConfigDb(parent)
{
    AbstractConfigConverter<RcConfig>::registerTypes();
}

void RcConfigDb::setConfig(const RcConfig &newConfig)
{
    if(!initialized)
        return;
    if (newConfig == config)
        return;
    config = newConfig;
    const auto &json = QVariant::fromValue(newConfig).value<QJsonObject>();
    write_config(json);
}

void RcConfigDb::update_config_from_db()
{
    const auto &json = readConfig(getConfigSelector());
    config = QVariant::fromValue(json).value<RcConfig>();
    // config.setRunState(false);
    config.pc.runEnable = false;
    config.removeInvalidEntries();
    emit configChanged(config);
}
