/*
**    Copyright 2014-2020 Ivan Filippov
**    Copyright 2014-2020 Ilja Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef RCCONFIGDB_H
#define RCCONFIGDB_H

#include "RcConfig.h"
#include "mongo/AbstractConfigDb.h"

//using RcConfigDb = AbstractConfigDb<RcConfig>;

class RcConfigDb  : public AbstractConfigDb
{
    Q_OBJECT

public:
    explicit RcConfigDb(QObject *parent = nullptr);

signals:
    void configChanged(const RcConfig &);

public slots:
    void setConfig(const RcConfig &newConfig);

protected:
    virtual void update_config_from_db() override;

private:
    RcConfig config;
};

#endif // RCCONFIGDB_H
