/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "VmeTrigsCore.h"

#include "RcConfigDispatcher.h"
#include "VmeTrigsController.h"
#include "mldiscover/DeviceDispatcher.h"

VmeTrigsCore::VmeTrigsCore(QObject *parent) :
    QObject(parent),
    deviceDispatcher(new DeviceDispatcher(this)),
    vmeTrigsController(new VmeTrigsController(this))

{
    connect(vmeTrigsController, &VmeTrigsController::trigConfigChanged,
            vmeTrigsController, &VmeTrigsController::setTrigConfig);

    connect(this, &VmeTrigsCore::printFsmInput,
            vmeTrigsController, &VmeTrigsController::printFsmInput);
    deviceDispatcher->setObjectName("VmeTrigsDeviceDispatcher");
    vmeTrigsController->setDeviceDispatcher(deviceDispatcher);
}

VmeTrigsCore::~VmeTrigsCore()
{
    // blank
}

void VmeTrigsCore::setConfigDispatcher(RcConfigDispatcher *p)
{
    vmeTrigsController->setConfigDispatcher(p);
}
