#ifndef AFIVIEWERCONFIGDB_H
#define AFIVIEWERCONFIGDB_H

#include "mongo/AbstractConfigDb.h"
#include "AfiViewerConfig.h"
#include "AfiViewerStartupOptions.h"

class AfiViewerConfigDb : public AbstractConfigDb
{
    Q_OBJECT
public:
    AfiViewerConfigDb(const AfiViewerStartupOptions &_startupOptions, QObject *parent);

signals:
    void configChanged(const AfiViewerConfig &);

public slots:
    void setConfig(const AfiViewerConfig &newConfig);

protected:
    virtual void update_config_from_db() override;

private:
    AfiViewerConfig config;
    AfiViewerStartupOptions startupOptions;
    bool startupOptionsUpplied = false;
};

#endif // AFIVIEWERCONFIGDB_H
