#ifndef SAVEINLDIALOG_H
#define SAVEINLDIALOG_H

#include <QDialog>

#include "base/DeviceIndex.h"
#include "histogramm/HistMngrWidget.h"

class QTreeWidgetItem;

namespace Ui {
class SaveInlDialog;
}

class SaveInlDialog : public QDialog
{
    Q_OBJECT

public:
    explicit SaveInlDialog(QWidget *parent = nullptr);
    void setInlResults(const InlResults &res);
    InlResults getInlResults() const;
    QString getPath() const;
    ~SaveInlDialog();

private slots:
    void on_treeWidget_itemChanged(QTreeWidgetItem *item, int column);
    void on_radioButtonSeparate_toggled(bool checked);
    void on_pushButtonChangeOutputFolder_clicked();
    void on_buttonBox_accepted();

private:
    void updateTreeItemStates();
    void updateButtonEnable();

    Ui::SaveInlDialog *ui;
    QTreeWidgetItem * const rootTreeItem;
    QMap<DeviceIndex, QTreeWidgetItem *> modTreeItem;
    InlResults inlResults;
    QString baseDir;
    bool separateFile;
};

#endif // SAVEINLDIALOG_H
