#include "ConfigConverterUtil.h"

namespace {
constexpr static const char *k_hi = "hi";
constexpr static const char *k_lo = "lo";
}

QJsonValue jsonValueFromUInt64(const quint64 &in)
{
    return QString::number(in);
    // old version via QJsonObject
    // QJsonObject out;
    // quint32 v = in>>32;
    // out[k_hi] = static_cast<qint32>(v);
    // v = in&0xFFFFFFFF;
    // out[k_lo] = static_cast<qint32>(v);
    // return out;
}

quint64 jsonValueToUInt64(const QJsonValue &_in)
{
    // return _in.toString().toULongLong();

    bool ok;
    auto v= _in.toString().toULongLong(&ok);
    if(ok)
        return v;
    // Try to recover old cfg value
    const auto &in = _in.toObject();
    quint64 out = static_cast<quint32>(in[k_hi].toInt());
    out <<= 32;
    out |= static_cast<quint32>(in[k_lo].toInt());
    return out;
}
