/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef THREADCONTROLLER_H
#define THREADCONTROLLER_H

#include <QObject>
#include <QPointer>
#include <QThread>

class ThreadController : public QObject
{
    Q_OBJECT
public:
    ThreadController(QObject *_obj, QObject *parent = nullptr);
    ThreadController(QObject *_obj, QThread::Priority priority, QObject *parent = nullptr);
    virtual ~ThreadController();

private:
    QPointer<QThread> objThread = nullptr;
    QPointer<QObject> const obj;
    QString formerAncestry;
};

#endif // THREADCONTROLLER_H
