#ifndef FSMSTATE_H
#define FSMSTATE_H

#include <QMetaType>
class QDebug;

enum class FsmState {
    Unknown, Init, Error, Ready, Configure, Starting, Run, Stopping, Calibrate, FindAdcDelay,
    CloseGlobTrig, WaitSpillEnd, OpenGlobTrig, PrepareStopping
};

Q_DECLARE_METATYPE(FsmState)

QString fsmStateToString(const FsmState &state);
FsmState getFsmState(const QString &str);

uint qHash(const FsmState &r, uint seed = 0);
QDebug operator <<(QDebug stream, const FsmState &state);

#endif // FSMSTATE_H
