/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef DEVICEINDEXTABLEMODEL_H
#define DEVICEINDEXTABLEMODEL_H

#include <QAbstractTableModel>
#include <QObject>
#include <QMap>

class DeviceIndex;

class DeviceIndexTableModel : public QAbstractTableModel
{
    Q_OBJECT
public:
    explicit DeviceIndexTableModel(QObject *parent = nullptr)
        : QAbstractTableModel{parent} {}

//    DeviceIndex deviceIndexOf(const QModelIndex &index) const;
    virtual DeviceIndex deviceIndexOf(int row) const = 0;
    virtual int rowOf(const DeviceIndex &sourceIndex) const = 0;

    virtual QVariant headerData(int section, Qt::Orientation orientation,
                                int role = Qt::DisplayRole) const override;

    virtual QMap<int, bool> defaultColumnState() const = 0;

protected:
    void invalidateRow(const DeviceIndex &deviceIndex);
};

#endif // DEVICEINDEXTABLEMODEL_H
