#ifndef AFISDBID_H
#define AFISDBID_H

#include <cstdint>

enum AFI_SDB_ID : uint32_t {
    AFI_SDB_UNKNOWN             = 0x00000000,

    AFI_SDB_ADC_LEMO_MUX_CTRL   = 0x2e0160f8,
    AFI_SDB_ADC_ZS              = 0x2fc0a72a, // removed
    AFI_SDB_AD5622              = 0x69a3a210,
    AFI_SDB_AD5328_x2_SPI       = 0x3524236a,
    AFI_SDB_ADC_Core            = 0xfd4368fa,
    AFI_SDB_ADC_DATA_TEST       = 0x286e09bb,
    AFI_SDB_ADC_ERC             = 0xa5fd23ba,
    AFI_SDB_ADC_MPD_TRIG        = 0xcb4e1468,
    AFI_SDB_ADS52J90_SPI        = 0xdd07b826,
    AFI_SDB_AD9249_SPI          = 0xba3e71ca,
    AFI_SDB_BOARD_GPIO          = 0x35f39554,
    AFI_SDB_Calibration_Trigger = 0x2c918620,
    AFI_SDB_Clock_Control       = 0x7bc301a9,
    AFI_SDB_Clock_Divider_Contr = 0x3ddcc6a5,
    AFI_SDB_CROSSPOINT_SWITCH   = 0x5e03c11a,
    AFI_SDB_DDR3_Stream_FIFO    = 0xf6a4e20c,
    AFI_SDB_Deserializers_Contr = 0x3efb27ee,
    AFI_SDB_ETH_PORT_V1         = 0xe050724f,
    AFI_SDB_FE_LINK_CSR         = 0x371a0421,
    AFI_SDB_FIR_FILTER          = 0x4237dc05,
    AFI_SDB_Flash               = 0x6e0f7007,
    AFI_SDB_HPTDC_RegIO_JTAG    = 0x1492d6c0,
    AFI_SDB_HWIP_ERR_CNTS       = 0x2a2a5a63,
    AFI_SDB_Input_Hit_Core      = 0x2324ece4,
    AFI_SDB_LTM9011_x2_SPI      = 0xde2766bc,
    AFI_SDB_MCU                 = 0x47567e3c, // from TQDC v2.0
    AFI_SDB_MCU1                = 0x8df3221b, // from TQDC v1
    AFI_SDB_MLINK_DIG_CSR       = 0x41a37c29,
    AFI_SDB_MLINK_CSR           = 0x50b1d9c7,
    AFI_SDB_MPD_TRC             = 0x8a3b62cd,
    AFI_SDB_MSC_CYCLE_COUNTERS  = 0x77268a46,
    AFI_SDB_MSC_HISTOGRAMS      = 0x8da907fb,
    AFI_SDB_MSC_INPUT           = 0xd26e4053,
    AFI_SDB_MSC_STREAM_READOUT  = 0xfd880c84,
    AFI_SDB_RUN_LOGIC           = 0xf4da37e8,
    AFI_SDB_SDB                 = 0x9d754a61,
    AFI_SDB_SPILL_CONTROL       = 0x315be6df,
    AFI_SDB_STAT_READOUT_CTRL   = 0xfb0bcd7f,
    AFI_SDB_TDC_RUN_STAT_CNTS   = 0x5d28c101,
    AFI_SDB_TDC_Trigger_Control = 0x76b80b88,
    AFI_SDB_TLU16SFP_Trigger    = 0x1ce0e2c7,
    AFI_SDB_TLU40LVDS_Luminosity= 0x9e8cb63c,
    AFI_SDB_TLU40LVDS_TOF_Trigger=0xcef86b29,
    AFI_SDB_TLU_Dec_Des         = 0x11f058c2,
    AFI_SDB_TLU_TTL_IO_Control  = 0xefa5e8d1,
    AFI_SDB_TRC_ERC             = 0x891f9f31,
    AFI_SDB_TRC_SYSTEM          = 0xe347158d,
    AFI_SDB_TRIG_INFO           = 0x510dbe12,
    AFI_SDB_TTL_IO_CTRL         = 0x8857c5c8,
    AFI_SDB_UT24VE_TTL_IO_CTRL  = 0x30f132b5,
    AFI_SDB_WAVE_BLC            = 0xc32e925e,
    AFI_SDB_WAVE_REC            = 0x7477e01e,
    AFI_SDB_WAVE_TRIG           = 0x3d1ca270,
    AFI_SDB_WR_STATUS           = 0xe5ea34bf,
    AFI_SDB_WR_TIME_EMULATOR    = 0x60120c01,
};

#endif // AFISDBID_H
