/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef DEVICEIDFILTER_H
#define DEVICEIDFILTER_H

#include <QSet>
#include <QSortFilterProxyModel>

#include "base/DeviceIndex.h"

class DeviceIdFilter : public QSortFilterProxyModel
{
    Q_OBJECT
public:
    DeviceIdFilter(QObject* parent = nullptr);

public slots:
    void setFilter(const DeviceIdSet &r);

protected:
    bool filterAcceptsRow(int sourceRow, const QModelIndex &sourceParent) const override;

private:
    DeviceIdSet filter;
};

#endif // DEVICEIDFILTER_H
