/*
**    Copyright 2015-2020 Ivan Filippov
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef MANUALADDDIALOG_H
#define MANUALADDDIALOG_H

#include <QDialog>
#include <QMap>

namespace Ui {
class ManualAddDialog;
}

class ManualAddDialog : public QDialog
{
    Q_OBJECT

public:
    explicit ManualAddDialog(QWidget *parent = nullptr);
    ~ManualAddDialog();
    quint64 getSerial() const;
    quint16 getDeviceId() const;
    void setDeviceIdMap(QMap<quint16, QString> deviceTypeMap);

private slots:
    void validateData() const;

private:
    Ui::ManualAddDialog * const ui;
    QMap<quint16, QString> deviceTypeMap;
};

#endif // MANUALADDDIALOG_H
