#include "AdcErcModule.h"

#include "AdcErcConfig.h"
#include "regio/regop.h"
#include "sdb/AfiSdbId.h"

namespace {
enum {
    REG_ID              = 0x0,
   REG_COTROL          = 0x2,
//    REG_LOCK            = 0x3,
    REG_SPARSE_CTRL     = 0x4,
    REG_SPARSE_CELL_NUM = 0x5,
    REG_SPARSE_PERIOD   = 0x6,
};

enum {
    ERC_BIT_EN    = 0x0001,
};
} // namespace

AdcErcModule::AdcErcModule(const MregBusInterface &bus) : BaseDeviceModule(bus)
{
}

QList<AFI_SDB_ID> AdcErcModule::getSupportedSdbIds()
{
    return {AFI_SDB_ADC_ERC};
}

bool AdcErcModule::writeConfig(const AdcErcConfig &config)
{
    RegOpVector r;
    r.RegWrite16(REG_COTROL, ERC_BIT_EN);
    quint16 sparseCtrl = config.sparse.en ? 1 : 0;
    r.RegWrite16(REG_SPARSE_CTRL, sparseCtrl);
    r.RegWrite16(REG_SPARSE_CELL_NUM, config.sparse.readCellNum);
    r.RegWrite16(REG_SPARSE_PERIOD, config.sparse.period);

    return regOpExecRebased(r);
}
