/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef BOARDGPIOSTATUS_H
#define BOARDGPIOSTATUS_H

#include <QtGlobal>

class TaiTime;

class BoardGpioStatus
{
public:
    friend bool operator==(const BoardGpioStatus &, const BoardGpioStatus &) = default;
    bool isValid() const;

    quint32 id = 0;
    quint16 size = 0;
    quint64 caps_tri = ~0ull;
    quint64 caps_in = ~0ull;
    quint64 caps_out = ~0ull;
    quint64 tri = ~0ull;
    quint64 in = 0;
    quint64 out = 0;
};

#endif // BOARDGPIOSTATUS_H
