/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "CrosspointSwitchConfigConverter.h"
#include "CrosspointSwitch/CrosspointSwitchConfig.h"

constexpr const char *k_out = "out";

template<>
bool AbstractConfigConverter<CrosspointSwitchConfig>::classIsObject()
{
    return true;
}

template<>
QJsonObject AbstractConfigConverter<CrosspointSwitchConfig>::toJsonObject(const CrosspointSwitchConfig &in)
{
    QVariantMap m;
    m[k_out] = ConfigConverterUtil::toJsonValue(in.out);
    return fromVariantMap(m);
}

template<>
CrosspointSwitchConfig AbstractConfigConverter<CrosspointSwitchConfig>::fromJsonObject(const QJsonObject &in)
{
    CrosspointSwitchConfig out;
    out.out = ConfigConverterUtil::toVector<quint16>(in[k_out]);
    return out;
}

template<>
QJsonValue AbstractConfigConverter<CrosspointSwitchConfig>::toJsonValue(const CrosspointSwitchConfig &in)
{
    return toJsonObject(in);
}

template<>
CrosspointSwitchConfig AbstractConfigConverter<CrosspointSwitchConfig>::fromJsonValue(const QJsonValue &in)
{
    return fromJsonObject(in.toObject());
}

template<>
void AbstractConfigConverter<CrosspointSwitchConfig>::registerSubTypes()
{
}
