/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "ModularDeviceConfig.h"

/// copy common data from cfg
void ModularDeviceConfig::unify_config(const ModularDeviceConfig &cfg)
{
    ModularDeviceConfig newConfig(cfg);
    newConfig.index = index;
    newConfig.enabled = enabled;
    newConfig.mergeLocalData(*this);
    *this = newConfig;
}

/// copy channel-based data from cfg
void ModularDeviceConfig::mergeLocalData(const ModularDeviceConfig &cfg)
{
    // modules
    adcMpdTrig = cfg.adcMpdTrig;
    tlu16SfpTrigger = cfg.tlu16SfpTrigger;
    tlu40lvdsLuminosity = cfg.tlu40lvdsLuminosity;
    tlu40lvdsTofTrigger = cfg.tlu40lvdsTofTrigger;
    tluDecDes = cfg.tluDecDes;
    tluTtlIo = cfg.tluTtlIo;
    feLink = cfg.feLink;
    trigCtrlStat.mergeLocalData(cfg.trigCtrlStat);
    waveBlc.mergeLocalData(cfg.waveBlc);
    waveRec.mergeLocalData(cfg.waveRec);
    waveTrig.mergeLocalData(cfg.waveTrig);
    serDesDelay = cfg.serDesDelay;
    ut24TtlIo = cfg.ut24TtlIo;
    // cores
    calResult = cfg.calResult;
    hrb.mergeLocalData(cfg.hrb);
    mscCore.mergeLocalData(cfg.mscCore);
    tdcCore.mergeLocalData(cfg.tdcCore);
    tqdcCore.mergeLocalData(cfg.tqdcCore);
    ttb.mergeLocalData(cfg.ttb);
    ttvxsCore.mergeLocalData(cfg.ttvxsCore);
}
