#ifndef MPDTRCMODULE_H
#define MPDTRCMODULE_H

#include "device-modules/BaseDeviceModule.h"

#include <optional>

#include "MpdTrcConfig.h"
#include "MpdTrcBuildParams.h"

class MpdTrcModule : public BaseDeviceModule<MpdTrcModule>
{
public:
    explicit MpdTrcModule(const MregBusInterface &bus) : BaseDeviceModule(bus) {}

    static QList<AFI_SDB_ID> getSupportedSdbIds();

    bool writeConfig(const MpdTrcConfig &config);
    std::optional<MpdTrcBuildParams> getBuildParam() const
    {
        return buildParams;
    }

protected:
    void post_init() override;

private:
    std::optional<MpdTrcBuildParams> buildParams;
};

#endif // MPDTRCMODULE_H
