#ifndef MSCSTREAMCONFIG_H
#define MSCSTREAMCONFIG_H

#include <QMetaType>
#include <QVector>

struct MscStreamConfig
{
    friend bool operator==(const MscStreamConfig &, const MscStreamConfig &) = default;
    bool en=false;
    quint16 timeout=100; // ms
    quint32 slice=10;    // ns
    QVector<bool> ceMonitor; // External count enable monitor
    static const bool HIST_CE_DEF;
    QVector<bool> histCe; // Apply histogram count enable mask for stream encoder, true by def.
};
Q_DECLARE_METATYPE(MscStreamConfig)

QDebug operator<<(QDebug dbg, const MscStreamConfig &s);
QDataStream &operator<<(QDataStream &out, const MscStreamConfig &r);
QDataStream &operator>>(QDataStream &in, MscStreamConfig &r);

#endif // MSCSTREAMCONFIG_H
