#ifndef MSCSTREAMMODULE_H
#define MSCSTREAMMODULE_H

#include <optional>
#include "device-modules/BaseDeviceModule.h"

#include "MscStreamBuildParams.h"

struct MscStreamConfig;

class MscStreamModule : public BaseDeviceModule<MscStreamModule>
{
public:
    explicit MscStreamModule(const MregBusInterface &bus) : BaseDeviceModule(bus) {}

    static QList<AFI_SDB_ID> getSupportedSdbIds();

    bool writeConfig(const MscStreamConfig &cfg);
    std::optional<MscStreamBuildParams> getBuildParam() const {
        return buildParams;
    }

protected:
    void post_init() override;

private:
    mlink::RegOpVector setConfigRegOp(const MscStreamConfig &cfg);
    inline quint16 getControlReg(const MscStreamConfig &cfg) const;
    quint16 getCeMonitorMask(const MscStreamConfig &cfg) const;
    quint64 getHistCeMask(const MscStreamConfig &cfg) const;

    std::optional<MscStreamBuildParams> buildParams;
};
#endif // MSCSTREAMMODULE_H
