#ifndef NETWORKPORTMODULE_H
#define NETWORKPORTMODULE_H

#include <optional>
#include "device-modules/BaseDeviceModule.h"

struct NetworkPortConfig;
struct NetworkPortStatus;
class NetworkPortModulePrivate;

class NetworkPortModule : public BaseDeviceModule<NetworkPortModule>
{
public:
    explicit NetworkPortModule(const MregBusInterface &bus);
    ~NetworkPortModule() override;

    void post_init() override;
    static QList<AFI_SDB_ID> getSupportedSdbIds();

    std::optional<NetworkPortStatus> readStatus();
    bool setConfig(const NetworkPortConfig &config);

    Q_DECLARE_PRIVATE(NetworkPortModule)
    NetworkPortModulePrivate * const d_ptr;
    QSet<uint32_t> regioErrorAddrSet;
};

#endif // NETWORKPORTMODULE_H
