#include "RcCounters.h"

QString getDevCountersType(DevCountersTypes type, int typeId) {
    const static QStringList hRcFull = {
        "Time (Total)",
        "Edge (Total)",
        "Time (Run)",
        "Edge (Run)",
        "Time (Spill)",
        "Edge (Spill)",
        "Time (Run & Spill)",
        "Edge (Run & Spill)",
//        "Edge (XOFF high timeout)",
//        "Edge (XOFF low timeout)",
//        "Edge (15 unused + Hamming code errors)",
//        "Edge (15 unused + event number)"
    };
    const static QStringList hTrcIn = {
        "xOff",
        "~xOff",
        "xOff & Run",
        "~xOff & Run",
        "xOff & Spill",
        "~xOff & Spill",
        "xOff & Run & Spill",
        "~xOff & Run & Spill"
    };
    const static QStringList hTrcBa = {
        "Before (Total)",
        "After (Total)",
        "Before (Run)",
        "After (Run)",
        "Before (Spill)",
        "After (Spill)",
        "Before (Run & Spill)",
        "After (Run & Spill)"
    };

    const QStringList *list=nullptr;
    switch (type) {
    case DevCountersRc: list = &hRcFull; break;
    case DevCountersTrcIn: list = &hTrcIn; break;
    case DevCountersTrcBa: list = &hTrcBa; break;
    case DevCountersTrcReduc: list = &hTrcIn; break;
    }

    QString t = list ? list->value(typeId) : QString();
    auto ret = t.isNull() ? QString("type #%1").arg(typeId) : t;
    if(type == DevCountersTrcReduc)
        ret += "(after reduc.)";
    return ret;
}

quint64 TrcInputCounters::totalCnt(const BaseDevCounters &cnts, int ch)
{
    return static_cast<quint64>(cnts.cnt[0][ch]+cnts.cnt[1][ch]);
}
