#include "RcCountersModule.h"

#include "regio/regop.h"

#include "RcCounters.h"

namespace {
constexpr const uint16_t REG64_CNT_TYPE_COUNT = 8; // number of types
constexpr const uint16_t REG64_CNT_TYPE_SIZE = 16; // 16 64-bit registers in each block
}

QList<AFI_SDB_ID> RcCountersModule::getSupportedSdbIds()
{
    return {};
}

bool RcCountersModule::readStatus(BaseDevCounters *map)
{
    RegOpVector r;

    // counters lock should be in upper level
    for (uint16_t type = 0; type < REG64_CNT_TYPE_COUNT; ++type) {
        for (quint16 ch = 0; ch < REG64_CNT_TYPE_SIZE; ++ch) {
            quint16 p = (type * REG64_CNT_TYPE_SIZE + ch) * 4;
            r.RegRead64(p, &map->cnt[type][ch]);
        }
    }
    return regOpExecRebased(r);
}
