#ifndef RUNLOGICMODULE_H
#define RUNLOGICMODULE_H

#include <optional>

#include "device-modules/BaseDeviceModule.h"

class RunLogicConfig;
class RunLogicStatus;

class RunLogicModule : public BaseDeviceModule<RunLogicModule>
{
public:
    explicit RunLogicModule(const MregBusInterface &bus) : BaseDeviceModule(bus) {}

    static QList<AFI_SDB_ID> getSupportedSdbIds();
    DeviceModuleCommandResult runCommand(const DeviceModuleCommand &command) override;

    bool writeReset();
    bool writeConfig(const RunLogicConfig &config);
    bool writeSoftRun(bool state);
    std::optional<RunLogicStatus> readStatus();
    bool readStatus(RunLogicStatus *result);

private:
};

#endif // RUNLOGICMODULE_H
