/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef TRIGINFOMODULE_H
#define TRIGINFOMODULE_H

#include <optional>
#include "device-modules/BaseDeviceModule.h"

struct TrigInfoStatus;

class TrigInfoModule : public BaseDeviceModule<TrigInfoModule>
{
public:
    explicit TrigInfoModule(const MregBusInterface &bus);

    static QList<AFI_SDB_ID> getSupportedSdbIds();

    bool softreset();
    bool writeGlobEvNum(quint64 value, bool withReset = true);

    bool readStatus(TrigInfoStatus *result);
    std::optional<TrigInfoStatus> readStatus();
};

#endif // TRIGINFOMODULE_H
