/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "TtbModuleConfigConverter.h"
#include "base/AbstractConfigConverter.h"
#include "device-modules/Ttb/TtbModuleConfig.h"

namespace {
constexpr const char *k_chEn = "chEn";
} // namespace

template<>
bool AbstractConfigConverter<TtbModuleConfig>::classIsObject()
{
    return true;
}

template<>
QJsonObject AbstractConfigConverter<TtbModuleConfig>::toJsonObject(const TtbModuleConfig &in)
{
    QVariantMap m;
    m[k_chEn] = ConfigConverterUtil::toJsonValue(in.chEn);
    return fromVariantMap(m);
}

template<>
TtbModuleConfig AbstractConfigConverter<TtbModuleConfig>::fromJsonObject(const QJsonObject &in)
{
    TtbModuleConfig out;
    out.chEn = ConfigConverterUtil::toMap<int, bool>(in[k_chEn]);
    return out;
}

template<>
QJsonValue AbstractConfigConverter<TtbModuleConfig>::toJsonValue(const TtbModuleConfig &in)
{
    return toJsonObject(in);
}

template<>
TtbModuleConfig AbstractConfigConverter<TtbModuleConfig>::fromJsonValue(const QJsonValue &in)
{
    return fromJsonObject(in.toObject());
}

template<>
void AbstractConfigConverter<TtbModuleConfig>::registerSubTypes()
{}
