#include "Ut24TtlIoConfigConverter.h"

#include "Ut24TtlIoConfig.h"

#include "base/ConfigConverterUtil.h"

template<>
bool AbstractConfigConverter<Ut24TtlIoConfig>::classIsObject()
{
    return false;
}

template<>
QJsonObject AbstractConfigConverter<Ut24TtlIoConfig>::toJsonObject(const Ut24TtlIoConfig &in)
{
    Q_UNUSED(in)
    Q_UNREACHABLE();
}

template<>
Ut24TtlIoConfig AbstractConfigConverter<Ut24TtlIoConfig>::fromJsonObject(const QJsonObject &in)
{
    Q_UNUSED(in)
    Q_UNREACHABLE();
}

template<>
QJsonValue AbstractConfigConverter<Ut24TtlIoConfig>::toJsonValue(const Ut24TtlIoConfig &in)
{
    QList<quint16> list;
    for(auto v : in.ttlCfg)
        list << v.all;
    return ConfigConverterUtil::toJsonValue(list);
}

template<>
Ut24TtlIoConfig AbstractConfigConverter<Ut24TtlIoConfig>::fromJsonValue(const QJsonValue &in)
{
    const auto &list = ConfigConverterUtil::toList<quint16>(in);
    Ut24TtlIoConfig out;
    for(auto v : list) {
        out.ttlCfg.push_back(reg_ut24_ttl_io_t{.all = v});
    }
    return out;
}

template<>
void AbstractConfigConverter<Ut24TtlIoConfig>::registerSubTypes()
{
}
