#ifndef UT24TTLIOMODULE_H
#define UT24TTLIOMODULE_H

#include "device-modules/BaseDeviceModule.h"

#include <optional>

#include "Ut24TtlIoConfig.h"
#include "Ut24TtlIoBuildParams.h"

class Ut24TtlIoModule : public BaseDeviceModule<Ut24TtlIoModule>
{
public:
    explicit Ut24TtlIoModule(const MregBusInterface &bus) : BaseDeviceModule(bus) {}

    static QList<AFI_SDB_ID> getSupportedSdbIds();

    bool writeConfig(const Ut24TtlIoConfig &config);
    std::optional<Ut24TtlIoConfig> getInitConfig() const {
        return initConfig;
    }
    std::optional<Ut24TtlIoBuildParams> getBuildParam() const {
        return buildParams;
    }

protected:
    void post_init() override;

private:
    std::optional<Ut24TtlIoConfig> readConfig();

    std::optional<Ut24TtlIoBuildParams> buildParams;
    std::optional<Ut24TtlIoConfig> initConfig;
};

#endif // UT24TTLIOMODULE_H
