#include "AdcMpdTrigPolarityDelegate.h"

#include "AdcMpdTrigPolarityWidget.h"

QWidget *AdcMpdTrigPolarityDelegate::createEditor(QWidget *parent,
                                                  const QStyleOptionViewItem &,
                                                  const QModelIndex &index) const
{
    const auto &var = index.model()->data(index, Qt::EditRole);
    if (var.isNull())
        return {};

    auto w = new AdcMpdTrigPolarityWidget(parent);
    connect(w, &AdcMpdTrigPolarityWidget::stateChanged,
            this, &AdcMpdTrigPolarityDelegate::dataChanged);

    updateWidgetByModel(w, index);

    return w;
}

void AdcMpdTrigPolarityDelegate::setEditorData(QWidget *editor,
                                               const QModelIndex &index) const
{
    auto w = static_cast<AdcMpdTrigPolarityWidget*>(editor);
    if (!w)
        return;
    updateWidgetByModel(w, index);
}

void AdcMpdTrigPolarityDelegate::setModelData(QWidget *editor,
                                              QAbstractItemModel *model,
                                              const QModelIndex &index) const
{
    auto w = static_cast<AdcMpdTrigPolarityWidget*>(editor);
    auto value = w->currentState();
    if(model->data(index, Qt::EditRole) != value)
        model->setData(index, value, Qt::CheckStateRole);
}

void AdcMpdTrigPolarityDelegate::updateEditorGeometry(QWidget *editor,
                                                      const QStyleOptionViewItem &option,
                                                      const QModelIndex &) const
{
    editor->setGeometry(option.rect);
}

void AdcMpdTrigPolarityDelegate::dataChanged()
{
    commitData(qobject_cast<QWidget*>(sender()));
}

void AdcMpdTrigPolarityDelegate::updateWidgetByModel(AdcMpdTrigPolarityWidget *w,
                                                     const QModelIndex &index) const
{
    auto var = index.model()->data(index, Qt::EditRole)
                   .value<Qt::CheckState>();

    QSignalBlocker blocker(w);
    w->setState(var);
    auto en = index.model()->flags(index) & Qt::ItemIsEnabled;
    w->setEnabled(en);
}
