#ifndef SINGLEUT24TTLWIDGET_H
#define SINGLEUT24TTLWIDGET_H

#include <QWidget>
#include <optional>

class QLabel;
class QComboBox;

#include "Ut24TtlIo/Ut24TtlIoConfig.h"
#include "Ut24TtlIo/Ut24TtlIoBuildParams.h"

class SingleUt24TtlWidget : public QWidget
{
    Q_OBJECT
public:
    SingleUt24TtlWidget(int id, const Ut24TtlIoBuildParams &bp, QWidget *parent = nullptr);
    ~SingleUt24TtlWidget();
    void setTrigInputNameMap(const std::function<QString (const int)> &);
    void setRegConfig(const reg_ut24_ttl_io_t &regCfg);
    void onUt24TtlIoBuildParamsChange(const Ut24TtlIoBuildParams &bp);
    void updateItems() const;

    const int ch;
    QLabel * const lab;
    QComboBox * const cb;
    std::optional<Ut24TtlIoBuildParams> buildParams;
    std::function<QString(const int)> trigInputNameMapFunc = nullptr;
};

#endif // SINGLEUT24TTLWIDGET_H
