#include "DeviceHelper.h"

#include <QSemaphore>

#include "base/DeviceId.h"
#include "base/DeviceIndex.h"

#include "HistParams.h"

bool skip_work(const QSemaphore *sem)
{
    int freeSpace=sem->available();
    const double max=DATA_QUEUE_SIZE*0.9, min=DATA_QUEUE_SIZE*0.4, delta=max-min;
    if(freeSpace>max)
        return false;
    double s;
    if(freeSpace<min)
        s=999;
    else
        s=999*(max-freeSpace)/delta;

    const int v = rand()%1000;
    bool res = v<s;
//    if(previousProceed)
//        qInfo()<<"freeSpace="<<freeSpace<<"  RandNumber="<<rand<<" threshold="<<s<<(res?" - skipp":" - proceed");

    return res;
}

int getTdcChNum(const DeviceIndex &index)
{
    switch (index.getDevId()) {
    case DEVICE_ID_TDC72VXS:
        return 72;
    case DEVICE_ID_TDC64VHLE:
    case DEVICE_ID_TDC64VLE:
        return 64;
    case DEVICE_ID_PHOS_FEC:
        return 32;
    case DEVICE_ID_TQDC16VS_E:
        return 16;
    default:
        return 0;
    }
}

int getAdcChNum(const DeviceIndex &index)
{
    switch (index.getDevId()) {
    case DEVICE_ID_ADC64:
    case DEVICE_ID_ADC64S2:
    case DEVICE_ID_ADC64VE:
    case DEVICE_ID_ADC64VE_XGE:
    case DEVICE_ID_ADC64ECAL:
    case DEVICE_ID_ADC64VE2:
    case DEVICE_ID_ADC64WR:
        return 64;
    case DEVICE_ID_PHOS_FEC:
    case DEVICE_ID_TRC: // 16 phy + 16 possible aux
        return 32; // use this method for tdc ch num
    case DEVICE_ID_TQDC16VS_E:
        return 16;
    default:
        return 0;
    }
}
