/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef READOUTAPPCONFIGDB_H
#define READOUTAPPCONFIGDB_H

#include "mongo/AbstractConfigDb.h"
#include "lib-common/BaseDeviceAppConfig.h"
#include <QObject>

class ConfigKey;

class ReadoutAppConfigDb : public AbstractConfigDb
{
    Q_OBJECT
public:
    explicit ReadoutAppConfigDb(QObject *parent = nullptr);
public:

signals:
    void configChanged(const BaseDeviceAppConfig &);

public slots:
    void setConfig(const ConfigKey &config_key, const BaseDeviceAppConfig &newConfig);

protected:
    virtual void update_config_from_db() override;

private:
    BaseDeviceAppConfig config;
};

#endif // READOUTAPPCONFIGDB_H
