#ifndef BASECONFIG_H
#define BASECONFIG_H

#include <QJsonObject>

class QDateTime;

class AbstractDB;
class ConfigDocument;
class ConfigSelector;
class ConfigurationName;
class DaqModule;
class ProgramIndex;
struct RunDocument;

class BaseConfig
{
public:
    BaseConfig();
    void connectToDb();

    ConfigDocument readConfigDocument(const ConfigSelector &cs);
    QJsonObject readConfig(const ConfigSelector &cs);
    bool writeConfigDocument(ConfigDocument &cd);
    bool writeConfig(const ConfigSelector &cs, const QJsonObject &jsonCfg);
    bool writeRunDocument(const RunDocument &runDoc);
    bool delete_config(const ConfigSelector &cs);
    QMap<ProgramIndex, QMap<ConfigurationName, QDateTime> > get_config_map(const DaqModule &program_type);

#ifdef MONGO_DRIVERS
    bool synchronization(const DaqModule &program_type);
#endif

    QList<QSharedPointer<AbstractDB>> dbList;
};

#endif // BASECONFIG_H
