#ifndef MONGO_ACCESS_H
#define MONGO_ACCESS_H

#include <memory>

#ifndef Q_MOC_RUN
#include <bsoncxx/stdx/optional.hpp>
#include <mongocxx/instance.hpp>
#include <mongocxx/pool.hpp>
#endif

class mongo_access {
public:
    static mongo_access& instance();
    bool configure(const std::string &uri);
    mongocxx::pool::entry get_connection();
    bsoncxx::stdx::optional<mongocxx::pool::entry> try_get_connection();

private:
    mongo_access();
    ~mongo_access();

    std::unique_ptr<mongocxx::instance> _instance;
    std::unique_ptr<mongocxx::pool> _pool = nullptr;
    bool destroyed = false;
};

#endif // MONGO_ACCESS_H
