#ifndef SINGLEMULTICASTLISTENER_H
#define SINGLEMULTICASTLISTENER_H

#include <QHostAddress>
#include <QMetaType>
#include <QNetworkInterface>
#include <QObject>

class QUdpSocket;
Q_DECLARE_METATYPE(QHostAddress)

class SingleMultiCastListener : public QObject
{
    Q_OBJECT

public:
    explicit SingleMultiCastListener(QObject *parent,
                                     QNetworkInterface interface = QNetworkInterface(),
                                     QHostAddress _groupAddress = QHostAddress(),
                                     quint16 port = 0);
    virtual ~SingleMultiCastListener();

signals:
    void received(const QByteArray &, const QHostAddress &host, int ttl);

private slots:
    void processPendingDatagrams();
    void start();
    void stop();

private:
    QUdpSocket *udpSocket;
    QHostAddress groupAddress;
};

#endif // SINGLEMULTICASTLISTENER_H
